GNU Trove

## gnu.trove
Class TShortDoubleIterator

    java.lang.Object
      gnu.trove.TShortDoubleIterator

    public class TShortDoubleIterator

extends java.lang.Object

Iterator for maps of type short and double.

The iterator semantics for Trove's primitive maps is slightly different from those defined in `java.util.Iterator`, but still well within the scope of the pattern, as defined by Gamma, et al.

This iterator does not implicitly advance to the next entry when the value at the current position is retrieved. Rather, you must explicitly ask the iterator to `advance()` and then retrieve either the `key()`, the `value()` or both. This is done so that you have the option, but not the obligation, to retrieve keys and/or values as your application requires, and without introducing wrapper objects that would carry both. As the iteration is stateful, access to the key/value parts of the current map entry happens in constant time.

In practice, the iterator is akin to a "search finger" that you move from position to position. Read or write operations affect the current entry only and do not assume responsibility for moving the finger.

Here are some sample scenarios for this class of iterator:

     // accessing keys/values through an iterator:
     for (TShortDoubleIterator it = map.iterator();
          it.hasNext();) {
       it.advance();
       if (satisfiesCondition(it.key()) {
         doSomethingWithValue(it.value());
       }
     }

     // modifying values in-place through iteration:
     for (TShortDoubleIterator it = map.iterator();
          it.hasNext();) {
       it.advance();
       if (satisfiesCondition(it.key()) {
         it.setValue(newValueForKey(it.key()));
       }
     }

     // deleting entries during iteration:
     for (TShortDoubleIterator it = map.iterator();
          it.hasNext();) {
       it.advance();
       if (satisfiesCondition(it.key()) {
         it.remove();
       }
     }

     // faster iteration by avoiding hasNext():
     TShortDoubleIterator iterator = map.iterator();
     for (int i = map.size(); i-- > 0;) {
       iterator.advance();
       doSomethingWithKeyAndValue(iterator.key(), iterator.value());
     }

Version:
  $Id: P2PIterator.template,v 1.1 2006/11/10 23:28:00 robeden Exp $
Author:
  Eric D. Friedman

Field Summary
`protected int` `_expectedSize` the number of elements this iterator believes are in the data structure it accesses.
`protected TPrimitiveHash` `_hash` the collection on which this iterator operates.
`protected int` `_index` the index used for iteration.

Constructor Summary
`TShortDoubleIterator(TShortDoubleHashMap map)` Creates an iterator over the specified map

Method Summary
`void` `advance()` Moves the iterator forward to the next entry in the underlying map.
`boolean` `hasNext()` Returns true if the iterator can be advanced past its current location.
`short` `key()` Provides access to the key of the mapping at the iterator's position.
`protected void` `moveToNextIndex()` Sets the internal `index` so that the `next' object can be returned.
`protected int` `nextIndex()` Returns the index of the next value in the data structure or a negative value if the iterator is exhausted.
`void` `remove()` Removes the last entry returned by the iterator.
`double` `setValue(double val)` Replace the value of the mapping at the iterator's position with the specified value.
`double` `value()` Provides access to the value of the mapping at the iterator's position.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### _hash

    protected final TPrimitiveHash _hash

  the collection on which this iterator operates.

### _expectedSize

    protected int _expectedSize

  the number of elements this iterator believes are in the data structure it accesses.

### _index

    protected int _index

  the index used for iteration.

Constructor Detail

### TShortDoubleIterator

    public TShortDoubleIterator(TShortDoubleHashMap map)

  Creates an iterator over the specified map

Method Detail

### advance

    public void advance()

  Moves the iterator forward to the next entry in the underlying map.

  Throws:
    `java.util.NoSuchElementException` - if the iterator is already exhausted

### key

    public short key()

  Provides access to the key of the mapping at the iterator's position. Note that you must `advance()` the iterator at least once before invoking this method.

  Returns:
    the key of the entry at the iterator's current position.

### value

    public double value()

  Provides access to the value of the mapping at the iterator's position. Note that you must `advance()` the iterator at least once before invoking this method.

  Returns:
    the value of the entry at the iterator's current position.

### setValue

    public double setValue(double val)

  Replace the value of the mapping at the iterator's position with the specified value. Note that you must `advance()` the iterator at least once before invoking this method.

  Parameters:
    `val` - the value to set in the current entry
  Returns:
    the old value of the entry.

### nextIndex

    protected final int nextIndex()

  Returns the index of the next value in the data structure or a negative value if the iterator is exhausted.

  Returns:
    an `int` value
  Throws:
    `java.util.ConcurrentModificationException` - if the underlying collection's size has been modified since the iterator was created.

### hasNext

    public boolean hasNext()

  Returns true if the iterator can be advanced past its current location.

  Returns:
    a `boolean` value

### remove

    public void remove()

  Removes the last entry returned by the iterator. Invoking this method more than once for a single entry will leave the underlying data structure in a confused state.

### moveToNextIndex

    protected final void moveToNextIndex()

  Sets the internal `index` so that the `next' object can be returned.

GNU Trove

GNU Trove is copyright © 2001-2009 Eric D. Friedman. All Rights Reserved.